//+------------------------------------------------------------------+
//|                                         i-Regression_Channel.mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                            "http://www.mql4.com/ru/users/costy_" |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
#property copyright "Copyright  2010, MetaQuotes Software Corp."
#property link      "http://www.mql4.com/ru/users/costy_"

#property indicator_chart_window
extern string     xxxxxxxxxxxxxxxxxxxxxxxxxxxxx =  "---------------------------------------------------------";
extern int    hours=24;
extern int    days=5;
extern int    weeks=4;
extern int    font_size = 8;
extern string font_name = "Times New Roman";
extern color  color_hours= Blue;
extern color  color_s    = Gold;
extern string     _ =  "_";
extern bool  Fix= true;

int i,ii,iii,shift_hours,shift_days,shift_weeks,save_bar_shift;
string name_object[21];
// init      
int init(){  
   for (  i=0; i<=20; i++)name_object[i]="name_"+MathRand()+i;
   shift_hours=60*   hours/Period();   shift_days =1440* days /Period();   shift_weeks=10080*weeks/Period();
   return(0);
  }
// deinit      
int deinit(){  for (  i=0; i<=20; i++)ObjectDelete(name_object[i]);Comment("");
  return(0);
  }
//     
int start(){
//     
  if(Close[shift_weeks]==0||Close[shift_days]==0||Close[shift_hours]==0)Alert(" History Bars "+"\n"+" ->->. "+"\r\n"+"     .  "+"\r\n"+"   "+(shift_weeks+20)+"  OK."+"\r\n"+"  "+Bars+" Bars");
//     
     if(ObjectFind(name_object[0])!=-1)
     for (  i=0; i<=20; i++)ObjectDelete(name_object[i]);
//     
     int shift_[6];shift_[0]=shift_hours; shift_[1]=shift_[0];shift_[2]=shift_days;  shift_[3]=shift_[2];shift_[4]=shift_weeks; shift_[5]=shift_[4];
     int OBJ_[5]={4,6,4,6,4,6};
     color color_[5];  for (  i=0; i<=5; i++)if(i<=1)color_[i] =color_hours; else color_[i] =color_s; 
     int STYLE_[5]={0,2,0,2,0,2}; 
//   
   if(Fix){
       if(ObjectFind("begin")!=-1)save_bar_shift=iBarShift(NULL, 0, ObjectGet("begin", OBJPROP_TIME1)); 
       if(ObjectFind("begin")<0&&save_bar_shift==0){
        ObjectCreate("begin", OBJ_VLINE,0,iTime(0,0,shift_hours),0);
        ObjectSet("begin",OBJPROP_STYLE,STYLE_DOT);
        ObjectSetText("begin","        - ", font_size, font_name, Green);
       }else{
        ObjectCreate("begin", OBJ_VLINE,0,iTime(0,0,save_bar_shift),0);
        ObjectSet("begin",OBJPROP_STYLE,STYLE_DOT);
        ObjectSetText("begin","        - ", font_size, font_name, Green);
       }
       shift_[0]=iBarShift(NULL, 0, ObjectGet("begin", OBJPROP_TIME1)); shift_[1]=shift_[0];
   }
//   
     for ( int g=0; g<=5; g++){
       ObjectCreate(name_object[g],  OBJ_[g],    0,iTime(0,0,shift_[g]),0,Time[1],0);
       ObjectSet(name_object[g],OBJPROP_COLOR, color_[g]);
       ObjectSet(name_object[g],OBJPROP_RAY,   true     );
       ObjectSet(name_object[g],OBJPROP_STYLE, STYLE_[g]);
      }
//     
return(0);
}
//     

